import { TestBed, async, ComponentFixture } from '@angular/core/testing';
import { WjGridModule } from '@grapecity/wijmo.angular2.grid';
import { FlexGrid } from '@grapecity/wijmo.grid';
import { hasClass } from '@grapecity/wijmo';
import { AppComponent } from './app.component';

describe('AppComponent', () => {
  let fixture: ComponentFixture<AppComponent>;
  let component: AppComponent;

  beforeEach(async(() => {
    TestBed.configureTestingModule({
      declarations: [
        AppComponent
      ],
      imports: [
        WjGridModule
      ]
    }).compileComponents();

    fixture = TestBed.createComponent(AppComponent);
    component = fixture.debugElement.componentInstance;
    fixture.detectChanges();
  }));

  it('should create the component', () => {
    expect(component).toBeTruthy();
  });

  it('Flexgrid instance should be initialized', () => {
    // fixture.
    expect(component.grid).toBeTruthy();

  });

  it('Item formatter should paint some cells red', () => {
    const grid: FlexGrid = component.grid;

    // find row index where sales value is less than 5000
    let rIndex = grid.rows.findIndex(r => r.dataItem.sales < 5000);
    // find col index of sales column
    let cIndex = grid.columns.findIndex(c => c.binding === 'sales');
    // make sure that cell is in view
    grid.scrollIntoView(rIndex, cIndex, true);
    // get cell element
    let cell = grid.cells.getCellElement(rIndex, cIndex);
    // check if red-color class is applied the cell
    expect(hasClass(cell, 'red-color')).toBeTruthy();
  });
});
