import { Component, OnInit, ViewChild } from '@angular/core';
import { addClass } from '@grapecity/wijmo';
@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent implements OnInit {
  @ViewChild('grid', { static: false }) grid;
  data = [];

  ngOnInit() {
    this.data = this.getSampleData(10);
  }

  initGrid(grid) {
    // attach format item to show sales less than 5000 with red color
    grid.formatItem.addHandler((s, e) => {
      if (e.panel !== s.cells) {
        return;
      }

      const col = e.panel.columns[e.col];
      const dataItem = e.panel.rows[e.row].dataItem;
      if (col.binding === 'sales' && dataItem['sales'] < 5000) {
        addClass(e.cell, 'red-color');
      }

    });
  }

  getSampleData(count: number) {
    // create some random data
    let countries = 'US,Germany,UK,Japan,Italy,Greece'.split(',');
    let data = [];
    for (let i = 0; i < count; i++) {
      data.push({
        id: i,
        date: new Date(2015, i % 12, (i + 1) % 25),
        time: new Date(2015, i % 12, (i + 1) % 25, i % 24, i % 60, i % 60),
        country: countries[i % countries.length],
        countryMapped: i % countries.length,
        downloads: Math.round(Math.random() * 20000),
        sales: Math.random() * 10000,
        expenses: Math.random() * 5000,
        checked: Boolean(Math.floor(Math.random() + 0.5))
      });
    }
    return data;
  }
}
